# -*- coding: utf-8 -*-
include Chef::Mixin::ShellOut

class Chef
  class Resource
    # drone user resource
    class DroneUser < Chef::Resource
      identity_attr :name

      # rubocop:disable MethodLength
      def initialize(name, run_context = nil)
        super
        @resource_name = :drone_user
        @provider = Chef::Provider::DroneUser
        @action = :create
        @allowed_actions = [:ls, :info, :add, :rm, :create, :list, :remove]
        @name = name
        @returns = [0]
        @options = nil
      end

      def name(arg = nil)
        set_or_return(:name, arg, kind_of: [String])
      end

    end
  end
end

class Chef
  class Provider
    # drone user provider
    class DroneUser < Chef::Provider

      use_inline_resources

      def whyrun_supported?
        true
      end

      # implement load_current_resource method to load previous resource before action
      def load_current_resource
        @current_resource = Chef::Resource::DroneUser.new(@new_resource.name)
        @current_resource.name(@new_resource.name)
        @current_resource
      end

      def exist?(name)
        Mixlib::ShellOut.new("drone user info #{name}", environment: { 'LC_ALL' => nil }).run_command.exitstatus == 0
      end

    end
  end
end
